## john 1.9.0

=== src/Makefile ===
#
# This file is part of John the Ripper password cracker,
# Copyright (c) 1996-2015,2019 by Solar Designer
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted.
#
# There's ABSOLUTELY NO WARRANTY, express or implied.
#

CC = gcc
AS = $(CC)
LD = $(CC)
CPP = $(CC)
CP = cp
LN = ln -sf
RM = rm -f
TR = tr
SED = sed
NULL = /dev/null
CPPFLAGS = -E
OMPFLAGS =
# gcc with OpenMP
#OMPFLAGS = -fopenmp
# gcc with OpenMP on 32-bit x86 with SSE2
#OMPFLAGS = -fopenmp -msse2
# Mac OS X (llvm-gcc) with OpenMP
#OMPFLAGS = -fopenmp -D_FORTIFY_SOURCE=0
# icc with OpenMP
#OMPFLAGS = -openmp
# Sun Studio with OpenMP (set the OMP_NUM_THREADS env var at runtime)
#OMPFLAGS = -xopenmp
CFLAGS = -c -Wall -O2 -fomit-frame-pointer $(OMPFLAGS)
# CFLAGS for use on the main john.c file only
CFLAGS_MAIN = $(CFLAGS)
ASFLAGS = -c $(OMPFLAGS)
LDFLAGS = -s $(OMPFLAGS)
OPT_NORMAL = -funroll-loops
# Remove the "-Os" if you're using an ancient version of gcc
OPT_INLINE = -Os -funroll-loops -finline-functions

JOHN_OBJS = \
	DES_fmt.o DES_std.o DES_bs.o DES_bs_b.o \
	BSDI_fmt.o \
	MD5_fmt.o MD5_std.o \
	BF_fmt.o BF_std.o \
	AFS_fmt.o \
	LM_fmt.o \
	trip_fmt.o \
	dummy.o \
	batch.o bench.o charset.o common.o compiler.o config.o cracker.o \
	crc32.o external.o formats.o getopt.o idle.o inc.o john.o list.o \
	loader.o logger.o memory.o misc.o options.o params.o path.o \
	recovery.o rpp.o rules.o signals.o single.o status.o tty.o wordlist.o \
	unshadow.o \
	unafs.o \
	unique.o

BENCH_DES_OBJS_ORIG = \
	DES_fmt.o DES_std.o

BENCH_DES_OBJS_DEPEND = \
	$(BENCH_DES_OBJS_ORIG)

BENCH_DES_BS_OBJS_DEPEND = \
	DES_bs_b.o

BENCH_MD5_OBJS_DEPEND = \
	MD5_fmt.o MD5_std.o

BENCH_BF_OBJS_DEPEND = \
	BF_fmt.o BF_std.o

BENCH_OBJS = \
	$(BENCH_DES_OBJS_DEPEND) \
	DES_bs.o $(BENCH_DES_BS_OBJS_DEPEND) \
	$(BENCH_MD5_OBJS_DEPEND) \
	$(BENCH_BF_OBJS_DEPEND) \
	bench.o best.o common.o config.o formats.o memory.o miscnl.o \
	params.o path.o signals.o tty.o

PROJ = ../run/john ../run/unshadow ../run/unafs ../run/unique
PROJ_DOS = ../run/john.bin ../run/john.com \
	../run/unshadow.com ../run/unafs.com ../run/unique.com
PROJ_WIN32 = ../run/john.exe \
	../run/unshadow.exe ../run/unafs.exe ../run/unique.exe

default:
	@echo "To build John the Ripper, type:"
	@echo "	make clean SYSTEM"
	@echo "where SYSTEM can be one of the following:"
	@echo "linux-x86-64-avx512      Linux, x86-64 with AVX-512 (some 2017+ Intel CPUs)"
	@echo "linux-x86-64-avx2        Linux, x86-64 with AVX2 (some 2013+ Intel CPUs)"
	@echo "linux-x86-64-xop         Linux, x86-64 with AVX and XOP (some AMD CPUs)"
	@echo "linux-x86-64-avx         Linux, x86-64 with AVX (some 2011+ Intel CPUs)"
	@echo "linux-x86-64             Linux, x86-64 with SSE2 (most common)"
#	@echo "linux-x86-64-32-sse2     Linux, x86-64, 32-bit with SSE2"
#	@echo "linux-x86-64-32-mmx      Linux, x86-64, 32-bit with MMX"
#	@echo "linux-x86-64-32-any      Linux, x86-64, 32-bit"
	@echo "linux-x86-avx512         Linux, x86 32-bit with AVX-512 (some 2017+ Intel CPUs)"
	@echo "linux-x86-avx2           Linux, x86 32-bit with AVX2 (some 2013+ Intel CPUs)"
	@echo "linux-x86-xop            Linux, x86 32-bit with AVX and XOP (some AMD CPUs)"
	@echo "linux-x86-avx            Linux, x86 32-bit with AVX (2011+ Intel CPUs)"
	@echo "linux-x86-sse2           Linux, x86 32-bit with SSE2 (most common, if 32-bit)"
	@echo "linux-x86-mmx            Linux, x86 32-bit with MMX (for old computers)"
	@echo "linux-x86-any            Linux, x86 32-bit (for truly ancient computers)"
	@echo "linux-mic                Linux, Intel MIC (first generation Xeon Phi)"
	@echo "linux-arm64le            Linux, ARM 64-bit little-endian w/ASIMD (best)"
	@echo "linux-arm32le-neon       Linux, ARM 32-bit little-endian w/NEON (best 32-bit)"
	@echo "linux-arm32le            Linux, ARM 32-bit little-endian"
	@echo "linux-alpha              Linux, Alpha"
	@echo "linux-sparc64            Linux, SPARC 64-bit"
	@echo "linux-sparc              Linux, SPARC 32-bit"
	@echo "linux-ppc32-altivec      Linux, PowerPC w/AltiVec (best)"
	@echo "linux-ppc32              Linux, PowerPC 32-bit"
	@echo "linux-ppc64-altivec      Linux, PowerPC 64-bit w/AltiVec"
	@echo "linux-ppc64              Linux, PowerPC 64-bit"
	@echo "linux-ia64               Linux, IA-64"
	@echo "freebsd-x86-64           FreeBSD, x86-64 with SSE2 (best)"
	@echo "freebsd-x86-sse2         FreeBSD, x86 with SSE2 (best if 32-bit)"
	@echo "freebsd-x86-mmx          FreeBSD, x86 with MMX"
	@echo "freebsd-x86-any          FreeBSD, x86"
	@echo "freebsd-alpha            FreeBSD, Alpha"
	@echo "openbsd-x86-64           OpenBSD, x86-64 with SSE2 (best)"
	@echo "openbsd-x86-sse2         OpenBSD, x86 with SSE2 (best if 32-bit)"
	@echo "openbsd-x86-mmx          OpenBSD, x86 with MMX"
	@echo "openbsd-x86-any          OpenBSD, x86"
	@echo "openbsd-alpha            OpenBSD, Alpha"
	@echo "openbsd-sparc64          OpenBSD, SPARC 64-bit (best)"
	@echo "openbsd-sparc            OpenBSD, SPARC 32-bit"
	@echo "openbsd-ppc32            OpenBSD, PowerPC 32-bit"
	@echo "openbsd-ppc64            OpenBSD, PowerPC 64-bit"
	@echo "openbsd-pa-risc          OpenBSD, PA-RISC"
	@echo "openbsd-vax              OpenBSD, VAX"
	@echo "netbsd-sparc64           NetBSD, SPARC 64-bit"
	@echo "netbsd-vax               NetBSD, VAX"
	@echo "solaris-sparc64-cc       Solaris, SPARC V9 64-bit, cc (best)"
	@echo "solaris-sparc64-gcc      Solaris, SPARC V9 64-bit, gcc"
	@echo "solaris-sparcv9-cc       Solaris, SPARC V9 32-bit, cc"
	@echo "solaris-sparcv8-cc       Solaris, SPARC V8 32-bit, cc"
	@echo "solaris-sparc-gcc        Solaris, SPARC 32-bit, gcc"
	@echo "solaris-x86-64-cc        Solaris, x86-64 with SSE2, cc (best)"
	@echo "solaris-x86-64-gcc       Solaris, x86-64 with SSE2, gcc"
	@echo "solaris-x86-sse2-cc      Solaris 9 4/04+, x86 with SSE2, cc"
	@echo "solaris-x86-sse2-gcc     Solaris 9 4/04+, x86 with SSE2, gcc"
	@echo "solaris-x86-mmx-cc       Solaris, x86 with MMX, cc"
	@echo "solaris-x86-mmx-gcc      Solaris, x86 with MMX, gcc"
	@echo "solaris-x86-any-cc       Solaris, x86, cc"
	@echo "solaris-x86-any-gcc      Solaris, x86, gcc"
	@echo "tru64-alpha              Tru64 (Digital UNIX, OSF/1), Alpha"
	@echo "aix-ppc32                AIX, PowerPC 32-bit"
	@echo "macosx-x86-64            Mac OS X 10.5+, Xcode 3.0+, x86-64 with SSE2 (best)"
	@echo "macosx-x86-sse2          Mac OS X, x86 with SSE2"
	@echo "macosx-ppc32-altivec     Mac OS X, PowerPC w/AltiVec (best)"
	@echo "macosx-ppc32             Mac OS X, PowerPC 32-bit"
#	@echo "macosx-ppc64-altivec     Mac OS X, PowerPC 64-bit w/AltiVec"
	@echo "macosx-ppc64             Mac OS X 10.4+, PowerPC 64-bit"
	@echo "macosx-universal         Mac OS X, Universal Binary (x86 + x86-64 + PPC)"
	@echo "hpux-pa-risc-gcc         HP-UX, PA-RISC, gcc"
	@echo "hpux-pa-risc-cc          HP-UX, PA-RISC, ANSI cc"
	@echo "irix-mips64-r10k         IRIX, MIPS 64-bit (R10K) (best)"
	@echo "irix-mips64              IRIX, MIPS 64-bit"
	@echo "irix-mips32              IRIX, MIPS 32-bit"
	@echo "dos-djgpp-x86-mmx        DOS, DJGPP, x86 with MMX"
	@echo "dos-djgpp-x86-any        DOS, DJGPP, x86"
	@echo "win32-cygwin-x86-sse2    Win32, Cygwin, x86 with SSE2 (best)"
	@echo "win32-cygwin-x86-mmx     Win32, Cygwin, x86 with MMX"
	@echo "win32-cygwin-x86-any     Win32, Cygwin, x86"
	@echo "beos-x86-sse2            BeOS, x86 with SSE2 (best)"
	@echo "beos-x86-mmx             BeOS, x86 with MMX"
	@echo "beos-x86-any             BeOS, x86"
	@echo "generic                  Any other Unix-like system with gcc"

linux-x86-64-avx512:
	$(LN) x86-64.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86-64.o" \
		CFLAGS_MAIN="$(CFLAGS) -DJOHN_AVX512F -DHAVE_CRYPT" \
		CFLAGS="$(CFLAGS) -mavx512f -DHAVE_CRYPT" \
		ASFLAGS="$(ASFLAGS) -mavx512f" \
		LDFLAGS="$(LDFLAGS) -lcrypt"

linux-x86-64-avx2:
	$(LN) x86-64.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86-64.o" \
		CFLAGS_MAIN="$(CFLAGS) -DJOHN_AVX2 -DHAVE_CRYPT" \
		CFLAGS="$(CFLAGS) -mavx2 -DHAVE_CRYPT" \
		ASFLAGS="$(ASFLAGS) -mavx2" \
		LDFLAGS="$(LDFLAGS) -lcrypt"

linux-x86-64-xop:
	$(LN) x86-64.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86-64.o" \
		CFLAGS_MAIN="$(CFLAGS) -DJOHN_XOP -DHAVE_CRYPT" \
		CFLAGS="$(CFLAGS) -mxop -DHAVE_CRYPT" \
		ASFLAGS="$(ASFLAGS) -mxop" \
		LDFLAGS="$(LDFLAGS) -lcrypt"

linux-x86-64-avx:
	$(LN) x86-64.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86-64.o" \
		CFLAGS_MAIN="$(CFLAGS) -DJOHN_AVX -DHAVE_CRYPT" \
		CFLAGS="$(CFLAGS) -mavx -DHAVE_CRYPT" \
		ASFLAGS="$(ASFLAGS) -mavx" \
		LDFLAGS="$(LDFLAGS) -lcrypt"

linux-x86-64:
	$(LN) x86-64.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86-64.o" \
		CFLAGS="$(CFLAGS) -DHAVE_CRYPT" \
		LDFLAGS="$(LDFLAGS) -lcrypt"

# The linux-x86-64-32-* targets exist for testing of 32-bit builds on 64-bit
# systems.  We don't dare to add -m32 to the corresponding pure 32-bit targets
# in order for those to be usable with old gcc that doesn't recognize -m32.
# We do include -m32 in linux-x86-avx and higher, which imply recent enough
# gcc, so there's no need to have linux-x86-64-32-* counterparts to those.
linux-x86-64-32-sse2:
	$(LN) x86-sse.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86.o x86-sse.o" \
		CFLAGS="$(CFLAGS) -m32 -DHAVE_CRYPT" \
		ASFLAGS="$(ASFLAGS) -m32" \
		LDFLAGS="$(LDFLAGS) -m32 -lcrypt"

linux-x86-64-32-mmx:
	$(LN) x86-mmx.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86.o x86-mmx.o" \
		CFLAGS="$(CFLAGS) -m32 -DHAVE_CRYPT" \
		ASFLAGS="$(ASFLAGS) -m32" \
		LDFLAGS="$(LDFLAGS) -m32 -lcrypt"

linux-x86-64-32-any:
	$(LN) x86-any.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86.o" \
		CFLAGS="$(CFLAGS) -m32 -DHAVE_CRYPT" \
		ASFLAGS="$(ASFLAGS) -m32" \
		LDFLAGS="$(LDFLAGS) -m32 -lcrypt"

linux-x86-avx512:
	$(LN) x86-sse.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86.o" \
		CFLAGS_MAIN="$(CFLAGS) -m32 -DJOHN_AVX512F -DHAVE_CRYPT" \
		CFLAGS="$(CFLAGS) -m32 -mavx512f -DHAVE_CRYPT" \
		ASFLAGS="$(ASFLAGS) -m32 -mavx512f" \
		LDFLAGS="$(LDFLAGS) -m32 -lcrypt"

linux-x86-avx2:
	$(LN) x86-sse.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86.o" \
		CFLAGS_MAIN="$(CFLAGS) -m32 -DJOHN_AVX2 -DHAVE_CRYPT" \
		CFLAGS="$(CFLAGS) -m32 -mavx2 -DHAVE_CRYPT" \
		ASFLAGS="$(ASFLAGS) -m32 -mavx2" \
		LDFLAGS="$(LDFLAGS) -m32 -lcrypt"

linux-x86-xop:
	$(LN) x86-sse.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86.o" \
		CFLAGS_MAIN="$(CFLAGS) -m32 -DJOHN_XOP -DHAVE_CRYPT" \
		CFLAGS="$(CFLAGS) -m32 -mxop -DHAVE_CRYPT" \
		ASFLAGS="$(ASFLAGS) -m32 -mxop" \
		LDFLAGS="$(LDFLAGS) -m32 -lcrypt"

linux-x86-avx:
	$(LN) x86-sse.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86.o" \
		CFLAGS_MAIN="$(CFLAGS) -m32 -DJOHN_AVX -DHAVE_CRYPT" \
		CFLAGS="$(CFLAGS) -m32 -mavx -DHAVE_CRYPT" \
		ASFLAGS="$(ASFLAGS) -m32 -mavx" \
		LDFLAGS="$(LDFLAGS) -m32 -lcrypt"

linux-x86-sse2:
	$(LN) x86-sse.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86.o x86-sse.o" \
		CFLAGS="$(CFLAGS) -DHAVE_CRYPT" \
		LDFLAGS="$(LDFLAGS) -lcrypt"

linux-x86-mmx:
	$(LN) x86-mmx.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86.o x86-mmx.o" \
		CFLAGS="$(CFLAGS) -DHAVE_CRYPT" \
		LDFLAGS="$(LDFLAGS) -lcrypt"

linux-x86-any:
	$(LN) x86-any.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o x86.o" \
		CFLAGS="$(CFLAGS) -DHAVE_CRYPT" \
		LDFLAGS="$(LDFLAGS) -lcrypt"

linux-mic:
	$(LN) mic.h arch.h
	$(MAKE) $(PROJ) \
		JOHN_OBJS="$(JOHN_OBJS) c3_fmt.o" \
		CC=icc \
		CFLAGS="$(CFLAGS) -no-opt-prefetch -mmic -openmp -DHAVE_CRYPT" \
		LDFLAGS="$(LDFLAGS) -mmic -openmp -lcrypt" \
		OPT_INLINE="$(OPT_NORMAL) -finline-functions"
	@echo "You'll likely need to scp Intel's OpenMP runtime library such as /opt/intel/*/compiler/lib/mic/libiomp?.so over to the target MIC cards and set LD_LIBRARY_PATH in order to run the produced john binary"

=== debian/changelog ===
john (1.9.0-3) unstable; urgency=medium

  [ Simon Josefsson ]
  * Team upload.
  * Standards-Version: 4.7.2.
  * Drop Rules-Requires-Root: no.
  * Add B-D on libcrypt-dev.  Closes: #1106904.
  * Bump debian/* copyright years.
  * Use watch v5.

  [ Peter Wienemann ]
  * Do not clobber upstream's CREDITS file (Closes: #1048895)

 -- Simon Josefsson <simon@josefsson.org>  Thu, 13 Nov 2025 19:16:02 +0100

john (1.9.0-2) unstable; urgency=medium

  * Team upload.
  * Restrict current testsuite to amd64 and i386 architectures as
    --method=crypt and multialgorithm hash files are not supported
    in all architectures.

 -- Marcos Fouces <marcos@debian.org>  Sun, 14 Aug 2022 00:40:53 +0200

john (1.9.0-1) unstable; urgency=medium

  [ Marcos Fouces ]
  * Team upload.
  * New upstream version 1.9.0
  * Rework patches for new upstream release.
  * Remove acute accent in john.8 manual page.
  * Conversion of 'CREDITS' file to utf-8 encoding.

  [ Axel Beckert ]
  * Salsa CI: Ignore a specific assembler line in blhc. Adding $CPPFLAGS
    to it causes an unexpected FTBFS due to a missing file.

  [ Jan Gru ]
  * Add autopkgtests

 -- Marcos Fouces <marcos@debian.org>  Sat, 06 Aug 2022 20:29:52 +0200

=== debian/control ===
Source: john
Section: admin
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Julián Moreno Patiño <julian@debian.org>,
           Axel Beckert <abe@debian.org>
Build-Depends: debhelper-compat (= 13),
               dpkg-dev (>= 1.16.1~),
	       libcrypt-dev
Standards-Version: 4.7.2
Homepage: http://www.openwall.com/john/
Vcs-Browser: https://salsa.debian.org/pkg-security-team/john
Vcs-Git: https://salsa.debian.org/pkg-security-team/john.git

Package: john
Architecture: any
Depends: john-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: wordlist
Description: active password cracking tool
 John the Ripper is a tool designed to help systems administrators to
 find weak (easy to guess or crack through brute force) passwords, and
 even automatically mail users warning them about it, if it is desired.
 .
 Besides several crypt(3) password hash types most commonly found on
 various Unix flavors, supported out of the box are Kerberos AFS and
 Windows NT/2000/XP/2003 LM hashes, plus several more with contributed
 patches.

Package: john-data
Architecture: all
Enhances: john
Depends: ${misc:Depends}
Breaks: john (<= 1.7.2-1)
Multi-Arch: foreign
Description: active password cracking tool - character sets
 John the Ripper is a tool designed to help systems administrators to
 find weak (easy to guess or crack through brute force) passwords, and
 even automatically mail users warning them about it, if it is desired.
 .
 This package contains architecture-independent character sets usable by
 john.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Enable all hardening
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# This is for the target selection
CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

# This is to add missing hardening fortify functions export
CFLAGS += $(shell dpkg-buildflags --get CPPFLAGS)

CFLAGS += -DJOHN_SYSTEMWIDE=1
# See src/params.h

ifeq ($(OS),kfreebsd)
	# enabling crypt(3) for kfreebsd, there is a patch adding fmt_c3.o
	CFLAGS += -DHAVE_CRYPT
	LDFLAGS +=  -lcrypt
	# as we will use $(OS)-x86-*, it must be named freebsd, not kfreebsd
	OS := freebsd
endif

# arm FTBFS with -funroll-loops. Please see #476460
ifneq ($(CPU),arm)
	CFLAGS += -funroll-loops
endif

# selecting compilation target
ifeq ($(OS),hurd)
	TARGET := generic
else ifeq ($(CPU),i386)
	# targeting an unoptimized binary first
	TARGET := $(OS)-x86-any
	# enabling i386 fallbacks
	CFLAGS += -DCPU_FALLBACK
else ifeq ($(CPU),amd64)
	TARGET := $(OS)-x86-64
else ifeq ($(CPU),powerpc)
	TARGET := linux-ppc32
else ifeq ($(CPU),ppc64)
	TARGET := linux-ppc64
else ifeq ($(CPU),alpha)
	TARGET := linux-alpha
else ifeq ($(CPU),sparc)
	TARGET := linux-sparc
else ifeq ($(CPU),ia64)
	TARGET := linux-ia64
else
	TARGET := generic
endif

# please take a look at:
# https://buildd.debian.org/status/logs.php?pkg=john&ver=1.7.7-1
ifeq ($(OS),freebsd)
	# seems like freebsd targets don't like too much escaping
	CFLAGS += -DJOHN_SYSTEMWIDE_EXEC=\"/usr/lib/john\"
	CFLAGS += -DCFG_FULL_NAME=\"/etc/john/john.conf\"
else ifeq ($(TARGET),generic)
	# and it is just the same for generic targets:
	# armel, hurd-i386, mips, mipsel, and s390
	CFLAGS += -DJOHN_SYSTEMWIDE_EXEC=\"/usr/lib/john\"
	CFLAGS += -DCFG_FULL_NAME=\"/etc/john/john.conf\"
else
	# but, we need a lot of escaping for:
	# amd64, i386, ia64, powerpc, and sparc
	CFLAGS += -DJOHN_SYSTEMWIDE_EXEC=\\\"/usr/lib/john\\\"
	CFLAGS += -DCFG_FULL_NAME=\\\"/etc/john/john.conf\\\"
endif

# testing i386 for mmx instructions and sse2 extensions
ifeq ($(CPU),i386)
	ifneq ($(OS),hurd)
		MMX := $(shell grep -c '^flags.* mmx' /proc/cpuinfo)
		ifneq ($(MMX),0)
			HAVEMMX := 1
		endif
		SSE := $(shell grep -c '^flags.* sse2' /proc/cpuinfo)
		ifneq ($(SSE),0)
			HAVESSE := 1
		endif
	endif
endif

%:
	dh $@ --sourcedirectory=src --no-parallel

override_dh_auto_build:
	# building the selected target
	dh_auto_build -- clean $(TARGET)
ifeq ($(HAVEMMX),1)
	# renaming the non-mmx binary
	mv run/john run/john-non-mmx
	# building i386-mmx optimized binary
	dh_auto_build -- clean $(OS)-x86-mmx
endif
ifeq ($(HAVESSE),1)
	# renaming the non-sse2 binary
	mv run/john run/john-non-sse
	# building i386-sse2 optimized binary
	dh_auto_build -- clean $(OS)-x86-sse2
endif

override_dh_auto_install:
	# install the selected target
	dh_auto_install
	find . -name CREDITS -type f -exec \
	mkdir '{}'.utf8 \; -exec \
	iconv -f ISO-8859-1 -t UTF-8 '{}' -o '{}'.utf8/CREDITS \;

	# install fallbacks as needed
ifeq ($(HAVEMMX),1)
	dh_install run/john-non-mmx /usr/lib/john
endif
ifeq ($(HAVESSE),1)
	dh_install run/john-non-sse /usr/lib/john
endif

override_dh_auto_clean:
	dh_auto_clean
	# script-not-executable
	chmod +x debian/extra/cronjob
	find $(CURDIR) -name CREDITS.utf8 -type d | xargs --no-run-if-empty rm -rf

override_dh_auto_test:

=== debian/watch ===
Version: 5
Source: https://www.openwall.com/john/
Matching-Pattern: ./john-([\d\.]+)\.tar\.xz
Pgpsigurlmangle: s/$/.sign/

## john 1.9.0-Jumbo-1+git20211102

=== debian/changelog ===
john (1.9.0-Jumbo-1+git20211102-0kali10) kali-dev; urgency=medium

  [ Arnaud Rebillout ]
  * Drop build dependency dpkg-dev

  [ Steev Klimaszewski ]
  * Revert "Force building with gcc-11"
  * Add upstream patch to deal with SIMD and gcc-12

 -- Steev Klimaszewski <steev@kali.org>  Mon, 02 Jun 2025 23:23:14 -0500

john (1.9.0-Jumbo-1+git20211102-0kali9) kali-dev; urgency=medium

  * Update patch for Python 3.12 warnings
  * Drop obsolete constraint on dpkg-dev
  * Add Rules-Requires-Root: no

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 18 Sep 2024 08:56:23 +0700

john (1.9.0-Jumbo-1+git20211102-0kali8) kali-dev; urgency=medium

  * Fix various Python 3.12 SyntaxWarning

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 16 Sep 2024 22:50:38 +0700

john (1.9.0-Jumbo-1+git20211102-0kali7) kali-dev; urgency=medium

  * The tests run on arm64 so add it as supported architecture.
  * d/watch: Point to correct upstream repo url.
  * Update lintian overrides
  * d/rules: Disable SIMD on 32bit ARM architectures.

 -- Steev Klimaszewski <steev@kali.org>  Thu, 07 Dec 2023 11:55:12 -0600

john (1.9.0-Jumbo-1+git20211102-0kali6) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Update lintian override info format in d/john.lintian-overrides on line 2-3.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.
  * Update standards version to 4.6.2, no changes needed.

  [ Steev Klimaszewski ]
  * Import autopkgtests from Debian

 -- Steev Klimaszewski <steev@kali.org>  Mon, 06 Nov 2023 10:07:16 -0600

john (1.9.0-Jumbo-1+git20211102-0kali5) kali-dev; urgency=medium

  * Force building with gcc-11
  * Prepare for Release

 -- Steev Klimaszewski <steev@kali.org>  Wed, 09 Nov 2022 10:13:36 -0600

john (1.9.0-Jumbo-1+git20211102-0kali4) kali-dev; urgency=medium

  [ Daniel Ruiz de Alegría ]
  * Fix debian/watch issue with github releases page
  [ Steev Klimaszewski ]
  * Prepare for Release

 -- Steev Klimaszewski <steev@kali.org>  Mon, 07 Nov 2022 22:34:14 -0600

john (1.9.0-Jumbo-1+git20211102-0kali3) kali-dev; urgency=medium

  [ Arnaud Rebillout ]
  * Use dh_auto_install target to handle completion
  * Use execute_after rather than override, where applicable

  [ Daniel Ruiz de Alegría ]
  * Update kirbi2john from nidem/kerberoast

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Wed, 11 May 2022 20:31:14 +0200

john (1.9.0-Jumbo-1+git20211102-0kali2) kali-dev; urgency=medium

  [ Ben Wilson ]
  * Add XSBC-Original-Maintainer
  * Update email address

  [ Arnaud Rebillout ]
  * Add XS-Debian-Vcs-* fields

  [ Daniel Ruiz de Alegría ]
  * Fix zsh and bash completion
  * Use override_dh_install to rename and install shell autocompletion scripts
  * Add binaries for eapmd5tojohn and vncpcap2john
  * Symlink scripts inside run to /bin
  * Remove bash-completion build dependency

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Tue, 22 Feb 2022 11:01:29 +0100

john (1.9.0-Jumbo-1+git20211102-0kali1) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Sophie Brun ]
  * New upstream version 1.9.0-Jumbo-1+git20211102
  * Refresh patches
  * Add dh-python to properly manage the Python shebang
  * Remove README.FreeBSD
  * Use Standard 4 in debian/watch
  * Bump Standards-Version to 4.6.0 (no change)
  * Update debian/john.lintian-overrides

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 12 Nov 2021 10:17:39 +0100

john (1.9.0-Jumbo-1-0kali3) kali-dev; urgency=medium

  [ Raphaël Hertzog ]
  * Add GitLab's CI configuration file
  * Configure git-buildpackage for Kali
  * Update URL in GitLab's CI configuration file
  * Disable reprotest job for now

  [ Stefan Pietsch ]
  * Include most of the docs

 -- Raphaël Hertzog <raphael@offensive-security.com>  Fri, 13 Sep 2019 11:14:26 +0200

john (1.9.0-Jumbo-1-0kali2) kali-dev; urgency=medium

  * debian/rules: fix the build tor the different options

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 20 May 2019 13:40:43 +0200

john (1.9.0-Jumbo-1-0kali1) kali-dev; urgency=medium

  * Update debian/watch
  * New upstream version 1.9.0-Jumbo-1
  * Update Vcs-* fields for gitlab
  * Use debhelper-compat 12
  * Update debian/copyright
  * Add debian/gbp.conf
  * Refresh patches
  * Update installation for new source package
  * Build the AVX512* binaries
  * Remove useless upstream key
  * Spelling errors: add a patch and lintian-overrides
  * Build with hard flags and don't strip executables
  * Add missings FLAGS for cprepair binary

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 17 May 2019 11:33:45 +0200

john (1.8.0.13-jumbo-1-0kali4) kali-dev; urgency=medium

  * Install standalone programs (not anymore included in john) see 5206
  * Add other commands/utilities in usr/share/john
  * Install zsh and bash completion
  * Bump Standards Version to 4.3.0

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 15 Jan 2019 09:33:40 +0100

john (1.8.0.13-jumbo-1-0kali3) kali-dev; urgency=medium

  * debian/rules: fix the path of DCPU_FALLBACK_BINARY

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 09 Jan 2019 10:28:58 +0100

john (1.8.0.13-jumbo-1-0kali2) kali-dev; urgency=medium

  * Install the missing rules (fixes 5201)

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 07 Jan 2019 18:59:37 +0100

john (1.8.0.13-jumbo-1-0kali1) kali-experimental; urgency=medium

  * New upstream version 1.8.0.13-jumbo-1
  * Add missing build-deps zlib1g-dev
  * Update debian/copyright
  * Refresh patches and remove obsolete patches
  * Add a patch to use correct path in FLAGS
  * Update d/rules: build omp and non-omp binaries
  * d/control: update Maintainer and uploaders fields
  * Bump Standards-Version to 4.2.1

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 20 Dec 2018 16:47:42 +0100

john (1.8.0.6-jumbo-1-0kali9) kali-dev; urgency=medium



=== debian/control ===
Source: john
Section: admin
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-python,
               dpkg-dev (>= 1.16.1~),
               libgmp-dev,
               libpcap0.8-dev,
               libssl-dev,
               python3,
               zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://github.com/magnumripper/JohnTheRipper
XS-Debian-Vcs-Git: https://salsa.debian.org/pkg-security-team/john.git
XS-Debian-Vcs-Browser: https://salsa.debian.org/pkg-security-team/john
Vcs-Git: https://gitlab.com/kalilinux/packages/john.git
Vcs-Browser: https://gitlab.com/kalilinux/packages/john

Package: john
Architecture: any
Depends: john-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Suggests: wordlist
Description: active password cracking tool
 John the Ripper is a tool designed to help systems administrators to
 find weak (easy to guess or crack through brute force) passwords, and
 even automatically mail users warning them about it, if it is desired.
 .
 Besides several crypt(3) password hash types most commonly found on
 various Unix flavors, supported out of the box are Kerberos AFS and
 Windows NT/2000/XP/2003 LM hashes, plus several more with contributed
 patches.

Package: john-data
Architecture: all
Enhances: john
Depends: ${misc:Depends}, ${python3:Depends}
Breaks: john (<= 1.7.2-1)
Suggests: python3, ruby
Description: active password cracking tool - character sets
 John the Ripper is a tool designed to help systems administrators to
 find weak (easy to guess or crack through brute force) passwords, and
 even automatically mail users warning them about it, if it is desired.
 .
 This package contains architecture-independent character sets usable by
 john and architecture-independent scripts.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# This is for the target selection
CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

# selecting compilation target
ifeq ($(OS),hurd)
	TARGET := generic
else ifeq ($(CPU),i386)
	# targeting an unoptimized binary first
	TARGET := $(OS)-x86-any
else ifeq ($(CPU),amd64)
	# targeting an unoptimized binary first
	TARGET := $(OS)-x86-64
else ifeq ($(CPU),powerpc)
	TARGET := linux-ppc32
else ifeq ($(CPU),ppc64)
	TARGET := linux-ppc64
else ifeq ($(CPU),alpha)
	TARGET := linux-alpha
else ifeq ($(CPU),sparc)
	TARGET := linux-sparc
else ifeq ($(CPU),ia64)
	TARGET := linux-ia64
else
	TARGET := generic
endif

# This is to add missing hardening fortify functions export
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS)
export DEB_LDFLAGS_MAINT_APPEND=

# Custom compilation flags
DEB_CFLAGS_MAINT_APPEND += -DJOHN_SYSTEMWIDE -DJOHN_SYSTEMWIDE_EXEC=\"/usr/lib/john\" -DCFG_FULL_NAME=\"/etc/john/john.conf\"

ifeq ($(OS),kfreebsd)
	# enabling crypt(3) for kfreebsd, there is a patch adding fmt_c3.o
	DEB_CFLAGS_MAINT_APPEND += -DHAVE_CRYPT
	DEB_LDFLAGS_MAINT_APPEND += -lcrypt
	# as we will use $(OS)-x86-*, it must be named freebsd, not kfreebsd
	OS := freebsd
endif

# testing i386 for mmx instructions and sse2 extensions
ifeq ($(CPU),i386)
	ifneq ($(OS),hurd)
		HAVEMMX := 1
		HAVESSE := 1
	endif
endif

# Add the float abi, without this, the CI will error about neon intrinsics not
# being available (which is true)
ifeq ($(DEB_HOST_ARCH),armel)
	DEB_CFLAGS_MAINT_APPEND += -mfloat-abi=softfp -DJOHN_NO_SIMD
endif

ifeq ($(DEB_HOST_ARCH),armhf)
	DEB_CFLAGS_MAINT_APPEND += -mfloat-abi=hard -DJOHN_NO_SIMD
endif

# testing amd64 for xop and avx instructions (linux only)
ifeq ($(OS)-$(CPU),linux-amd64)
	HAVEXOP := 1
	HAVEAVX := 1
	HAVEAVX2 := 1
	HAVEAVX512F := 1
	HAVEAVX512BW := 1
endif

define build_target_cpu =
cd src && ./configure --disable-native-tests --disable-openmp CPPFLAGS='$(patsubst %,-m%,$(filter-out base,$(1)))'
$(MAKE) -C src clean
$(MAKE) -C src -j4
cp run/john run/john-$(1)-non-omp
if test -e debian/last-build; then \
    cd src && ./configure --disable-native-tests --enable-openmp CPPFLAGS='-m$(1) -DOMP_FALLBACK -DOMP_FALLBACK_BINARY="\"john-$(1)-non-omp\"" -DCPU_FALLBACK -DCPU_FALLBACK_BINARY="\"'"$$(cat ../debian/last-build)"'\""'; \
else \
	cd src && ./configure --disable-native-tests CPPFLAGS='-DOMP_FALLBACK -DOMP_FALLBACK_BINARY="\"john-$(1)-non-omp\""'; \
fi
$(MAKE) -C src clean
$(MAKE) -C src -j4
cp run/john run/john-$(1)-omp
echo "john-$(1)-omp" > debian/last-build
endef


%:
	dh $@ --sourcedirectory=src --with python3

override_dh_auto_configure:
	# Skip it

override_dh_auto_build:
	$(call build_target_cpu,base)
ifeq ($(HAVEAVX),1)
	$(call build_target_cpu,avx)
endif
ifeq ($(HAVEXOP),1)
	$(call build_target_cpu,xop)
endif
ifeq ($(HAVEAVX2),1)
	$(call build_target_cpu,avx2)
endif
ifeq ($(HAVEAVX512F),1)
	$(call build_target_cpu,avx512f)
endif
ifeq ($(HAVEAVX512BW),1)
	$(call build_target_cpu,avx512bw)
endif

ifeq ($(HAVEMMX),1)
	$(call build_target_cpu,mmx)
endif
ifeq ($(HAVESSE),1)
	$(call build_target_cpu,sse)
endif
	ln -sf "../lib/john/$$(cat debian/last-build)" debian/last-build-link

execute_after_dh_auto_install:
	# install link john in usr/sbin
	mkdir -p debian/john/usr/sbin
	mv debian/last-build-link debian/john/usr/sbin/john
	# install fallbacks as needed
	for binary in run/john-*; do \
	    test -x $$binary && dh_install $$binary /usr/lib/john/ || true; \
	done
	# install shell completions
	mkdir -p debian/john/usr/share/bash-completion/completions/
	cp run/john.bash_completion debian/john/usr/share/bash-completion/completions/john
	mkdir -p debian/john/usr/share/zsh/vendor-completions/
	cp run/john.zsh_completion debian/john/usr/share/zsh/vendor-completions/_john

execute_after_dh_link:
	for ext in pl py; do \
	    for script in run/*john.$$ext; do \
	        test -x $$script \
	          && dh_link -pjohn-data /usr/share/john/$$(basename $$script) /usr/bin/$$(basename $$script | sed "s/\.$$ext//") \
	          || true; \
	    done \
	done

override_dh_python3:
	dh_python3 --shebang="/usr/bin/env python3" /usr/share/john

execute_after_dh_auto_clean:
	# script-not-executable
	chmod +x debian/extra/cronjob

override_dh_auto_test:

override_dh_installdocs:
	dh_installdocs -XCONTACT -XLICENSE -XCOPYING -XINSTALL -Xextras -XFreeBSD

=== debian/tests/control ===
Tests: smoke, crack-crypt-with-wordlist, crack-bsdicrypt-formats-with-stdin, crack-descrypt-formats-with-stdin, crack-md5-formats-with-stdin, crack-sha256-formats-with-stdin, crack-sha512-formats-with-stdin, crack-sunmd5-formats-with-stdin
Restrictions: needs-root, allow-stderr
Architecture: amd64 arm64 i386

=== debian/watch ===
version=4
opts="filenamemangle=s/^.*\//john-/,uversionmangle=s/-PRE/~pre/" \
https://github.com/openwall/JohnTheRipper/tags .*/([\d\.]+-[j|J]umbo-.*)\.tar\.(?:xz|gz)
